#include "stdafx.h"
#include <iostream>
#include <stack>
#include <vector>
#include <conio.h>


using namespace std;

 // #define TEST

char topo(stack<char>& st)
{
	char aux = st.top();
	st.pop();
	return aux;
}

void showST(stack<char>& st)
{
	stack<char> aux;
	aux = st;
	cout << "STS : ";
	while(!aux.empty())
		cout << topo(aux) << " ";
	cout << endl;
}

void showVC(vector<char> vc)
{
	vector<char>::iterator ptr;
	cout << "ONP : ";

	for (ptr = vc.begin(); ptr < vc.end(); ++ptr)
		cout << *ptr;

	cout << endl << endl;
	
}

void wait()
{
	getch();
}


int Prior (char c)
{
	switch(c)
	{
		case '('	:	return 0;

		case '+'	:
		case '-'	:	
		case ')'	:	return 1;

		case '*'	:
		case '/'	:	return 2;
	}

	return 0;
}

int main()
{
	stack <char> ST;
	
	vector<char> Expr;
	vector<char> ONP;

	vector<char>::iterator expr;
	vector<char>::iterator  onp;
	
	char aux = ' ';

	cout << "\nWprowadz wyrazenie (liczby jednocyfrowe, zakoncz znakiem $ ) : \n";

	while (aux != '$')
	{
		Expr.push_back(aux);
		cin >> aux;
	}
	
	expr = Expr.begin();
	onp =  ONP.begin();

// translation

	while (expr < Expr.end())
		switch (*expr)
		{
			case ' '	:	expr++;
							break;

			case '('	:	ST.push(*expr++);
#ifdef TEST
							showST(ST);
							showVC(ONP);
							wait();
#endif
							break;

			case ')'	:	while (!ST.empty() && ST.top() != '(' )	
									ONP.push_back(topo(ST));
							expr++;
							ST.pop();
#ifdef TEST
							showST(ST);
							showVC(ONP);
							wait();
#endif
							break;

			case '+'	:
			case '-'	:
			case '*'	:
			case '/'	:	if (ST.empty())
								ST.push(*expr++);
							else
							{
								while (!ST.empty() && Prior(ST.top()) >= Prior(*expr) )
									ONP.push_back(topo(ST));
								ST.push(*expr++);
							}
#ifdef TEST
							showST(ST);
							showVC(ONP);
							wait();
#endif
							break;

			default		:	ONP.push_back(*expr++);
#ifdef TEST
							showST(ST);
							showVC(ONP);
							wait();

#endif
		}

	while(!ST.empty())
		if(ST.top() != '(')
			ONP.push_back(topo(ST));
		else
			ST.pop();

	cout << endl;
	showVC(ONP);

	cout << endl << "Nacisnij dowolny klawisz ... ";
	wait();

// execution

	onp = ONP.begin();

	while(onp < ONP.end())
	{
		switch (*onp)
		{
			case '+' :	ST.push(topo(ST) + topo(ST));
						break;

			case '-' :	aux = topo(ST);
						ST.push(topo(ST) - aux);
						break;

			case '*' :	ST.push(topo(ST) * topo(ST));
						break;

			case '/' :	aux = topo(ST);
						
						if (aux == 0)
						{
							cout << "\nPamietaj morelo nie dziel przez zero!\n\n";
							return 0;
						}
						
						ST.push(topo(ST) / aux);
						break;

			default	 :	ST.push(*onp - 0x30);
		}

		++onp;
	}


	cout << "\n\nWartosc wyrazenia = " << (int)ST.top() << endl;

	// cout << "\nSprawdzenie = " << ((3 + 7)*5)/(2-4)/3-(7-3)/4;

	cout << endl;

	return 0;
}
