#include "stdafx.h"
#include <iostream>
#include <queue>
#include <string>

using namespace std;

class Zadanie
{
	int Priorytet;
	char* Opis;
public:
	Zadanie(int, char* );
	friend bool operator < (Zadanie, Zadanie);  // less
	friend ostream& operator << (ostream&, Zadanie);
};

Zadanie::Zadanie(int pr = 0, char* op = NULL) :
                 Priorytet(pr), Opis(op)
{}

bool operator < (Zadanie z1, Zadanie z2)
{
	return z1.Priorytet < z2.Priorytet;
}

ostream& operator << (ostream& wy, Zadanie zz)
{
	wy << zz.Opis << " o priorytecie : " 
	   << zz.Priorytet << endl;
	return wy;
}

int _tmain(int argc, _TCHAR* argv[])
{

	priority_queue<Zadanie> ListaZadan;

	ListaZadan.push(Zadanie(5,  "Zad-1"));
	ListaZadan.push(Zadanie(12, "Zad-2"));
	ListaZadan.push(Zadanie(3,  "Zad-3"));
	ListaZadan.push(Zadanie(7,  "Zad-4"));

	cout << ListaZadan.top();
	ListaZadan.pop();

	ListaZadan.push(Zadanie(15, "Zad-5"));
	ListaZadan.push(Zadanie(4,  "Zad-6"));

	while (!ListaZadan.empty())
	{
		cout << ListaZadan.top();
		ListaZadan.pop();
	}

    cout << endl;
}